//Robo Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
//ѥɥ֥Ƚꤹ륯饹
public class PassAnalyzer implements Analyzer{
	
	/*************************************************/
	/*                  field                        */
	/*************************************************/

	AnalyzeInfo ai;

	//ǡ
	Vector passVector;
        Vector dribbleVector;
        Vector interceptVector;

	//ѥΥǡѲɤ
	//ѿ̾ѹɬפꡩ        
	boolean changed;

	//pass,dribbleʤɤϡkickʬϤ롣
	Vector kickVector;
	
	/*********************************************/
	/*               constructor                 */
	/*********************************************/
	
	public PassAnalyzer(Vector kickVector){

		this.ai = ai;

		passVector = new Vector();
		interceptVector = new Vector();

		this.kickVector = kickVector; 

	}		

	/***********************************************/
	/*                method                       */
	/***********************************************/

	public Vector getPassVector(){

		return passVector;

	}
	public void analyze(){
		
		Kick beforeKick;
		Kick thisKick;

		changed = false;

		int kickSize = kickVector.size(); 

		//ޤkick򣱲󤷤Ǥ롣
		if (kickSize == 1){

			return;				
	
		}
		
		beforeKick = (Kick)kickVector.elementAt(kickSize-2);	
		thisKick   = (Kick)kickVector.elementAt(kickSize-1);						

//
//	kickkickδ֤ˡplaymodeѲʤСѥȤϹͤʤ
//

		if ((beforeKick.member == -1) || (thisKick.member == -1)){
				
			return;

		}

			
		boolean sameTeam = (thisKick.member <= 10 &&  beforeKick.member <= 10) || (thisKick.member >= 11 && beforeKick.member >= 11);

                   
		//dribble
		if (sameTeam && (thisKick.member == beforeKick.member)){
		

			//ɥ֥λν򤳤˽񤭤ޤ


		//pass
		}else if (sameTeam && (thisKick.member != beforeKick.member)){

			double xx,yy,dist;

                	xx = beforeKick.posX - thisKick.posX;
                	yy = beforeKick.posY - thisKick.posY;

                	xx = xx / CParam.SHOWINFO_SCALE;
                	yy = yy / CParam.SHOWINFO_SCALE;

			dist = Math.sqrt(xx*xx + yy*yy);

			//å֤mʾ夢ʤСѥǧ
			if (dist >= 1.0){

	                        changed = true;

	                        passVector.addElement(new Pass(beforeKick.member , thisKick.member,
                                                       beforeKick.posX   , beforeKick.posY,
                                                       thisKick.posX , thisKick.posY,      
                                                       beforeKick.time   , thisKick.time   ));

				//System.out.println("pass is success kicker:"+beforeKick.member+"  receiver:"+thisKick.member);
			}

		}else {
			//
			//󥿡ץ
			//
			
                        interceptVector.addElement(new Intercept(beforeKick.member , thisKick.member,
                                                       beforeKick.posX   , beforeKick.posY,
                                                       thisKick.posX , thisKick.posY,
                                                       beforeKick.time   , thisKick.time ));

			//System.out.println("Intercept "+thisKick.member 
			//			+"  " + beforeKick.member+"kara");

		}
	
	}


	public int getTotalLeft(){

		int pass = 0;

		Enumeration enu = passVector.elements();		

		while(enu.hasMoreElements()){

			Pass p = (Pass)enu.nextElement();

			if (p.getPasserUnum() <= 10){
			
				pass++;				
			}
		}

		return pass;

	}
	
	public int getTotalRight(){

		int pass = 0;

		Enumeration enu = passVector.elements();


		while(enu.hasMoreElements()){

			Pass p = (Pass)enu.nextElement();

			if (p.getPasserUnum() >= 11){
			
				pass++;				
			}
		}

		return pass;

	}
	
	public int getPlayerPass(int unum){

                int pass = 0;

                Enumeration enu = passVector.elements();

                while(enu.hasMoreElements()){

                        Pass p = (Pass)enu.nextElement();

                        if (p.getPasserUnum() == unum){

                                pass++;
                        }
                }

		return pass;		


	}
	public int getTotal(short side){

		int result = 0;

		if (side == CParam.CType_LEFT){

			result = getTotalLeft();			

		}else if (side == CParam.CType_RIGHT){
			
			result = getTotalRight();
		
		}else{
			new IllegalArgumentException();
		}

		return result;

	}

    public int getTotalPassReceive(short side){

	int result = 0;

	if (side == CParam.CType_LEFT){

	    result = getTotalPassReceiveLeft();			

	}else if (side == CParam.CType_RIGHT){
			
	    result = getTotalPassReceiveRight();
		
	}else{
	    new IllegalArgumentException();
	}

	return result;

    }

	public int getTotalPassReceiveRight(){

		int receive = 0;

		Enumeration enu = passVector.elements();

		while(enu.hasMoreElements()){

			Pass p = (Pass)enu.nextElement();

			if (p.getReceiverUnum() >= 11){
			
			        receive++;				
			}
		}

		return receive;

	}

	public int getTotalPassReceiveLeft(){

		int receive = 0;

		Enumeration enu = passVector.elements();

		while(enu.hasMoreElements()){

			Pass p = (Pass)enu.nextElement();

			if (p.getReceiverUnum() <= 10){
			
			        receive++;				
			}
		}

		return receive;

	}



    public int getTotalPlayerPassReceive(int unum){

	int receive = 0;

	Enumeration enu = passVector.elements();

        while(enu.hasMoreElements()){

	    Pass p = (Pass)enu.nextElement();

	    //System.out.println("receive unum "+p.getIntercepterUnum());

	    if (p.getReceiverUnum() == unum){

		receive++;

	    }
	

	}
	return receive;

    }

	public int getTotalIntercept(short side){	

                int result = 0;

                if (side == CParam.CType_LEFT){

                        result = getTotalInterceptLeft();

                }else if (side == CParam.CType_RIGHT){

                        result = getTotalInterceptRight();

                }else{
                        new IllegalArgumentException();
                }

		

                return result;

	}


        public int getTotalInterceptRight(){

                int intercept = 0;

                Enumeration enu = interceptVector.elements();
 
                while(enu.hasMoreElements()){

                        Intercept i = (Intercept)enu.nextElement();

			//System.out.println(i.getIntercepterUnum());

			//intercepter!?
                        if (i.getIntercepterUnum() >= 11){

                                intercept++;
                        }
                }

                return intercept;
	}

        public int getTotalInterceptLeft(){

                int intercept = 0;

                Enumeration enu = interceptVector.elements();

                while(enu.hasMoreElements()){

                        Intercept i = (Intercept)enu.nextElement();

			//System.out.println(i.getIntercepterUnum());

                        if (i.getIntercepterUnum() <= 10){

                                intercept++;

                        }
                }

                return intercept;
        }

	public int getTotalPlayerIntercept(int unum){

                int intercept = 0;

                Enumeration enu = interceptVector.elements();

                while(enu.hasMoreElements()){

                        Intercept i = (Intercept)enu.nextElement();

                        //System.out.println(i.getIntercepterUnum());

                        if (i.getIntercepterUnum() == unum){

                                intercept++;

                        }
                }

                return intercept;

	}




}


 
